## yarock 1.3.1

=== CMakeLists.txt ===
# ------------------------------------------------------------------------------
#  YAROCK CMAKE FILE
# ------------------------------------------------------------------------------
cmake_minimum_required(VERSION 2.8.6)
set( CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake )

PROJECT( yarock )
set(YAROCK_MAJOR_VERSION 1)
set(YAROCK_MINOR_VERSION 3)
set(YAROCK_PATCH_VERSION 1)
set(YAROCK_VERSION "${YAROCK_MAJOR_VERSION}.${YAROCK_MINOR_VERSION}.${YAROCK_PATCH_VERSION}")

# ------------------------------------------------------------------------------
#  build def
# ------------------------------------------------------------------------------
#ADD_DEFINITIONS( -DTEST_FLAG )
ADD_DEFINITIONS(-Wall -Wextra )

# ------------------------------------------------------------------------------
#  OPTION
# ------------------------------------------------------------------------------
# Since yarock 1.1.5 change default audio engine to VLC
OPTION(ENABLE_PHONON "Enable/disable Phonon audio engine" OFF)
OPTION(ENABLE_VLC "Enable/disable VLC audio engine" ON)
OPTION(ENABLE_MPV "Enable/disable MPV audio engine" OFF)
# OPTION(ENABLE_QTMULTIMEDIA "Enable/disable QtMultimedia audio engine" OFF)

# Since yarock 1.1.5 change default qt5 
OPTION(ENABLE_QT5 "Enable/disable Qt5 build" ON)
OPTION(ENABLE_SHORTCUT "Enable/disable global shortcut manager" ON)

# ------------------------------------------------------------------------------
#  EXTERNAL PACKAGE
# ------------------------------------------------------------------------------


#---- Qt ----
if (ENABLE_QT5)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5Widgets_EXECUTABLE_COMPILE_FLAGS}")
    
    FIND_PACKAGE(Qt5Gui REQUIRED)
    FIND_PACKAGE(Qt5Widgets REQUIRED)
    FIND_PACKAGE(Qt5Xml REQUIRED)
    FIND_PACKAGE(Qt5Network REQUIRED)
    FIND_PACKAGE(Qt5Concurrent REQUIRED)
    FIND_PACKAGE(Qt5DBus REQUIRED)
    FIND_PACKAGE(Qt5Sql REQUIRED)
    FIND_PACKAGE(Qt5X11Extras REQUIRED)
    FIND_PACKAGE(Qt5LinguistTools REQUIRED)
    
    set (QTLIBS ${Qt5Core_LIBRARIES} 
                ${Qt5Widgets_LIBRARIES} 
                ${Qt5Network_LIBRARIES} 
                ${Qt5Xml_LIBRARIES} 
                ${Qt5Concurrent_LIBRARIES} 
                ${Qt5DBus_LIBRARIES} 
                ${Qt5Sql_LIBRARIES}
                ${Qt5X11Extras_LIBRARIES})
    
    set (QTINCLUDES ${Qt5Core_INCLUDE_DIRS}
                    ${Qt5Widgets_INCLUDE_DIRS}
                    ${Qt5Network_INCLUDE_DIRS}
                    ${Qt5Xml_INCLUDE_DIRS}
                    ${Qt5Concurrent_INCLUDE_DIRS} 
                    ${Qt5DBus_INCLUDE_DIRS} 
                    ${Qt5Sql_INCLUDE_DIRS})

    add_definitions( ${Qt5Core_DEFINITIONS} 
                     ${Qt5Widgets_DEFINITIONS} 
                     ${Qt5Network_DEFINITIONS} 
                     ${Qt5Xml_DEFINITIONS} 
                     ${Qt5Concurrent_DEFINITIONS})
else (ENABLE_QT5)
    FIND_PACKAGE(Qt4 4.7.0 REQUIRED QtCore QtGui QtXml QtNetwork QtSql QtDbus)

    set (QTLIBS ${QT_QTCORE_LIBRARY} 
                ${QT_QTGUI_LIBRARY} 
                ${QT_QTNETWORK_LIBRARY} 
                ${QT_QTXML_LIBRARY} 
                ${QT_QTDBUS_LIBRARY} 
                ${QT_QTSQL_LIBRARY})

    set (QTINCLUDES ${QT_INCLUDES})
    
    add_definitions(${QT_DEFINITIONS})    

endif (ENABLE_QT5)

 
# ---- QJson ----
if(NOT ENABLE_QT5)
    FIND_PACKAGE( QJSON REQUIRED )
endif (NOT ENABLE_QT5)

# ---- Taglib ----
FIND_PACKAGE( Taglib 1.6.0 REQUIRED )

if(TAGLIB_FOUND)
    include(CheckTagLibFileName)
    check_taglib_filename(COMPLEX_TAGLIB_FILENAME)
endif (TAGLIB_FOUND)

# ---- Htmlcxx ----
FIND_PACKAGE( HtmlCxx )

        
# ------------------------------------------------------------------------------
#  INCLUDES
# ------------------------------------------------------------------------------
INCLUDE_DIRECTORIES( ${QTINCLUDES} )
INCLUDE_DIRECTORIES( ${TAGLIB_INCLUDES} )
if(NOT ENABLE_QT5)
  INCLUDE_DIRECTORIES( ${QJSON_INCLUDE_DIR} )
endif (NOT ENABLE_QT5)
INCLUDE_DIRECTORIES( ${HTMLCXX_INCLUDE_DIRS} )
 
# ------------------------------------------------------------------------------
#  SUBDIRECTORIES
# ------------------------------------------------------------------------------
# global shortcut
if(ENABLE_SHORTCUT)
  add_definitions(-DENABLE_SHORTCUT)

  add_subdirectory(src/shortcuts)

  INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/src/shortcuts)
  
  set(LIB_INTERNAL_STATIC_SHORTCUT yarock_shortchut)

endif(ENABLE_SHORTCUT)

# ------------------------------------------------------------------------------
#  INSTALL DIRECTORIES
# ------------------------------------------------------------------------------
if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
   set (CMAKE_INSTALL_PREFIX /usr CACHE PATH "default install path" FORCE )
endif()

set(CMAKE_INSTALL_BIN          "${CMAKE_INSTALL_PREFIX}/bin"         CACHE PATH "binaries install path" FORCE)
set(CMAKE_INSTALL_LIB          "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}/yarock"  CACHE PATH "libraries install path" FORCE)
set(CMAKE_INSTALL_TRANS        "${CMAKE_INSTALL_PREFIX}/share/yarock/translations"  CACHE PATH "translations install path" FORCE)

# ------------------------------------------------------------------------------
#  configure file
# ------------------------------------------------------------------------------
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/src/config.h.in
               ${CMAKE_CURRENT_BINARY_DIR}/config.h)
               
# ------------------------------------------------------------------------------
#  SOURCES
# ------------------------------------------------------------------------------
add_subdirectory(src)

MESSAGE(STATUS "Audio Engine Vlc.................................................  " ${ENABLE_VLC} " [use cmake .. -DENABLE_VLC=ON/OFF]" )
if (ENABLE_VLC)
  add_definitions(-DENABLE_VLC)
  add_subdirectory(src/core/player/vlc)
endif (ENABLE_VLC)

MESSAGE(STATUS "Audio Engine Mpv.................................................  " ${ENABLE_MPV} " [use cmake .. -DENABLE_MPV=ON/OFF]")
if (ENABLE_MPV)
  add_definitions(-DENABLE_MPV)
  add_subdirectory(src/core/player/mpv)
endif (ENABLE_MPV)

MESSAGE(STATUS "Audio Engine Phonon..............................................  " ${ENABLE_PHONON} " [use cmake .. -DENABLE_PHONON=ON/OFF]")
if (ENABLE_PHONON)
  add_definitions(-DENABLE_PHONON)
  add_subdirectory(src/core/player/phonon)
endif (ENABLE_PHONON)

# MESSAGE(STATUS "Audio Engine QtMultimedia........................................  " ${ENABLE_QTMULTIMEDIA} " [use cmake .. -DENABLE_QTMULTIMEDIA=ON/OFF]")
# if (ENABLE_QTMULTIMEDIA)
#     if (ENABLE_QT5)
#       add_definitions(-DENABLE_QTMULTIMEDIA)
#       add_subdirectory(src/core/player/qtmultimedia)
#     else (ENABLE_QT5)
#       MESSAGE(WARNING "QtMultimedia can be set with QT5")
#     endif (ENABLE_QT5)
# endif (ENABLE_QTMULTIMEDIA)


INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR})
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR})
INCLUDE_DIRECTORIES(${CMAKE_BINARY_DIR})

INCLUDE_DIRECTORIES(${YAROCK_INCLUDES})

# ------------------------------------------------------------------------------
#  RESSOURCE
# ------------------------------------------------------------------------------
SET(YAROCK_RESOURCES yarock.qrc)


if (ENABLE_QT5)
  QT5_ADD_RESOURCES(YAROCK_RESOURCES_RCC ${YAROCK_RESOURCES})
else (ENABLE_QT5)
  QT4_ADD_RESOURCES(YAROCK_RESOURCES_RCC ${YAROCK_RESOURCES})
endif (ENABLE_QT5)


# ------------------------------------------------------------------------------
#  DBUS
# ------------------------------------------------------------------------------
# MPRIS 2.0 DBUS interfaces
if (ENABLE_QT5)
  qt5_add_dbus_adaptor(YAROCK_SOURCES
        src/dbus/org.mpris.MediaPlayer2.Player.xml
        src/dbus/mpris2.h Mpris2 mpris2Player Mpris2Player)
  qt5_add_dbus_adaptor(YAROCK_SOURCES
        src/dbus/org.mpris.MediaPlayer2.xml
        src/dbus/mpris2.h Mpris2 mpris2Root Mpris2Root)
else (ENABLE_QT5)
  qt4_add_dbus_adaptor(YAROCK_SOURCES
        src/dbus/org.mpris.MediaPlayer2.Player.xml
        src/dbus/mpris2.h Mpris2 mpris2Player Mpris2Player)
  qt4_add_dbus_adaptor(YAROCK_SOURCES
        src/dbus/org.mpris.MediaPlayer2.xml
        src/dbus/mpris2.h Mpris2 mpris2Root Mpris2Root)
endif (ENABLE_QT5)


# ------------------------------------------------------------------------------
#  TRANSLATION
# ------------------------------------------------------------------------------
# Handle Translations, take all * files from trans directory.
file( GLOB TRANS_FILES ${CMAKE_SOURCE_DIR}/translation/yarock_*.ts)
set(TS_FILES ${TRANS_FILES})

SET(UPDATE_TRANSLATIONS OFF) # no ts update
#SET(UPDATE_TRANSLATIONS ON) # ts update


option (UPDATE_TRANSLATIONS "Update source translation ../translation/*.ts files")
set (FILES_TO_TRANSLATE ${FILES_TO_TRANSLATE} ${YAROCK_SOURCES})

if (ENABLE_QT5)
  if (UPDATE_TRANSLATIONS)
    QT5_CREATE_TRANSLATION(YAROCK_QM_FILES ${FILES_TO_TRANSLATE} ${TS_FILES})
  else (UPDATE_TRANSLATIONS)
    QT5_ADD_TRANSLATION(YAROCK_QM_FILES ${TS_FILES})
  endif (UPDATE_TRANSLATIONS)
else (ENABLE_QT5)
  if (UPDATE_TRANSLATIONS)
    QT4_CREATE_TRANSLATION(YAROCK_QM_FILES ${FILES_TO_TRANSLATE} ${TS_FILES})
  else (UPDATE_TRANSLATIONS)
    QT4_ADD_TRANSLATION(YAROCK_QM_FILES ${TS_FILES})
  endif (UPDATE_TRANSLATIONS)
endif (ENABLE_QT5)

# ------------------------------------------------------------------------------
#  BUILDING
# ------------------------------------------------------------------------------
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Woverloaded-virtual -Wall -Wno-sign-compare")
    
ADD_EXECUTABLE(yarock ${YAROCK_SOURCES} ${YAROCK_RESOURCES_RCC} ${YAROCK_QM_FILES})

SET_TARGET_PROPERTIES(yarock PROPERTIES AUTOMOC TRUE)

SET_PROPERTY(TARGET  ${LIB_INTERNAL_STATIC_SHORTCUT} PROPERTY IMPORTED_LOCATION ${CMAKE_SOURCE_DIR}/shortcuts)

if(ENABLE_SHORTCUT)
  TARGET_LINK_LIBRARIES(yarock ${LIB_INTERNAL_STATIC_SHORTCUT})
endif(ENABLE_SHORTCUT)


TARGET_LINK_LIBRARIES(yarock
  X11
  ${QTLIBS}
  ${TAGLIB_LIBRARIES}
  ${HTMLCXX_LIBRARIES}
)

if(NOT ENABLE_QT5)  
  TARGET_LINK_LIBRARIES(yarock ${QJSON_LIBRARIES})
endif(NOT ENABLE_QT5)

 
# ------------------------------------------------------------------------------
#  INSTALL
# ------------------------------------------------------------------------------
# -- install binary file
install( TARGETS yarock DESTINATION ${CMAKE_INSTALL_BIN} )

# -- install translations files
install(FILES ${YAROCK_QM_FILES} DESTINATION "${CMAKE_INSTALL_PREFIX}/share/yarock/translations")

# -- install destop file
install(FILES data/yarock.desktop  DESTINATION "${CMAKE_INSTALL_PREFIX}/share/applications" )

# -- install appdata file
install(FILES data/yarock.appdata.xml  DESTINATION "${CMAKE_INSTALL_PREFIX}/share/appdata" )

# -- install icons files
INSTALL( FILES ${CMAKE_SOURCE_DIR}/icon/yarock_16x16.png DESTINATION "${CMAKE_INSTALL_PREFIX}/share/icons/hicolor/16x16/apps" RENAME application-x-yarock.png)
INSTALL( FILES ${CMAKE_SOURCE_DIR}/icon/yarock_32x32.png DESTINATION "${CMAKE_INSTALL_PREFIX}/share/icons/hicolor/32x32/apps" RENAME application-x-yarock.png)
INSTALL( FILES ${CMAKE_SOURCE_DIR}/icon/yarock_48x48.png DESTINATION "${CMAKE_INSTALL_PREFIX}/share/icons/hicolor/48x48/apps" RENAME application-x-yarock.png)
INSTALL( FILES ${CMAKE_SOURCE_DIR}/icon/yarock_64x64.png DESTINATION "${CMAKE_INSTALL_PREFIX}/share/icons/hicolor/64x64/apps" RENAME application-x-yarock.png)
INSTALL( FILES ${CMAKE_SOURCE_DIR}/icon/yarock_128x128.png DESTINATION "${CMAKE_INSTALL_PREFIX}/share/icons/hicolor/128x128/apps" RENAME application-x-yarock.png)
INSTALL( FILES ${CMAKE_SOURCE_DIR}/icon/yarock.svg DESTINATION "${CMAKE_INSTALL_PREFIX}/share/icons/hicolor/scalable/apps" RENAME application-x-yarock.svg)

# ------------------------------------------------------------------------------
#  UN-INSTALL SUPPORT
# ------------------------------------------------------------------------------

=== src/core/player/mpv/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

project(enginempv)
# ------------------------------------------------------------------------------
#  build def (QT PLUGIN)
# ------------------------------------------------------------------------------
ADD_DEFINITIONS( -Wall )
ADD_DEFINITIONS(-DQT_PLUGIN)
ADD_DEFINITIONS(-DQT_NO_DEBUG)
ADD_DEFINITIONS(-DQT_SHARED)
ADD_DEFINITIONS(-DQT_THREAD)


ADD_DEFINITIONS( -DENABLE_MPV )

# ------------------------------------------------------------------------------
#  EXTERNAL LIB
# ------------------------------------------------------------------------------
FIND_PACKAGE( LIBMPV REQUIRED)


# ------------------------------------------------------------------------------
#  INCLUDES
# ------------------------------------------------------------------------------
INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/core/player/
                     ${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/core/player/mpv
                     ${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/core/mediaitem
                     ${CMAKE_CURRENT_SOURCE_DIR}/../../../../src
)

INCLUDE_DIRECTORIES( ${LIBMPV_INCLUDE_DIR} )
  
if (ENABLE_QT5)
    set (QTLIBS ${Qt5Core_LIBRARIES})
    
    set (QTINCLUDES ${Qt5Core_INCLUDE_DIRS})

    add_definitions( ${Qt5Core_DEFINITIONS})

else (ENABLE_QT5)
    set (QTLIBS ${QT_QTCORE_LIBRARY})

    set (QTINCLUDES ${QT_INCLUDES})
    
    add_definitions(${QT_DEFINITIONS})    
endif (ENABLE_QT5)

INCLUDE_DIRECTORIES( ${QTINCLUDES} )

# ------------------------------------------------------------------------------
#  SOURCES
# ------------------------------------------------------------------------------
SET(SOURCES
    ${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/core/player/mpv/engine_mpv.cpp
)

# ------------------------------------------------------------------------------
#  BUILDING
# ------------------------------------------------------------------------------
set( CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib )

ADD_LIBRARY( enginempv SHARED ${SOURCES} )

SET_TARGET_PROPERTIES(enginempv PROPERTIES AUTOMOC TRUE)

ADD_DEPENDENCIES(enginempv yarock)

TARGET_LINK_LIBRARIES(enginempv ${LIBMPV_LIBRARY} ${QTLIBS})

# ------------------------------------------------------------------------------
#  INSTALL
# ------------------------------------------------------------------------------  
if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
   set (CMAKE_INSTALL_PREFIX /usr CACHE PATH "default install path" FORCE )
endif()

set(CMAKE_INSTALL_LIB "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}/yarock"  CACHE PATH "libraries installation path" FORCE)

install(TARGETS enginempv DESTINATION ${CMAKE_INSTALL_LIB} )

=== src/core/player/phonon/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

project(enginephonon)
# ------------------------------------------------------------------------------
#  build def (QT PLUGIN)
# ------------------------------------------------------------------------------
ADD_DEFINITIONS( -Wall )
ADD_DEFINITIONS(-DQT_PLUGIN)
ADD_DEFINITIONS(-DQT_NO_DEBUG)
ADD_DEFINITIONS(-DQT_SHARED)
ADD_DEFINITIONS(-DQT_THREAD)


ADD_DEFINITIONS( -DENABLE_PHONON )

# ------------------------------------------------------------------------------
#  EXTERNAL LIB
# ------------------------------------------------------------------------------
if(ENABLE_QT5)
    FIND_PACKAGE( Phonon4Qt5 REQUIRED )
else(ENABLE_QT5)
    FIND_PACKAGE( Phonon REQUIRED )
endif (ENABLE_QT5)    
 

# ------------------------------------------------------------------------------
#  INCLUDES
# ------------------------------------------------------------------------------
INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/core/player/
                     ${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/core/player/phonon
                     ${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/core/mediaitem
                     ${CMAKE_CURRENT_SOURCE_DIR}/../../../../src
)


if (ENABLE_QT5)
    INCLUDE_DIRECTORIES( ${PHONON_INCLUDE_DIR}/phonon4qt5 )
else (ENABLE_QT5)
    INCLUDE_DIRECTORIES( ${PHONON_INCLUDES} )
endif (ENABLE_QT5)  


if (ENABLE_QT5)
    set (QTLIBS ${Qt5Core_LIBRARIES})
    
    set (QTINCLUDES ${Qt5Core_INCLUDE_DIRS})

    add_definitions( ${Qt5Core_DEFINITIONS})

else (ENABLE_QT5)
    set (QTLIBS ${QT_QTCORE_LIBRARY})

    set (QTINCLUDES ${QT_INCLUDES})
    
    add_definitions(${QT_DEFINITIONS})    
endif (ENABLE_QT5)

INCLUDE_DIRECTORIES( ${QTINCLUDES} )

# ------------------------------------------------------------------------------
#  SOURCES
# ------------------------------------------------------------------------------
SET(SOURCES
    ${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/core/player/phonon/engine_phonon.cpp
)

# ------------------------------------------------------------------------------
#  BUILDING
# ------------------------------------------------------------------------------
set( CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib )

ADD_LIBRARY( enginephonon SHARED ${SOURCES} )

SET_TARGET_PROPERTIES(enginephonon PROPERTIES AUTOMOC TRUE)

ADD_DEPENDENCIES(enginephonon yarock)

if(ENABLE_QT5)  
    TARGET_LINK_LIBRARIES(enginephonon ${PHONON4QT5_LIBRARY} ${QTLIBS})
else(ENABLE_QT5)
    TARGET_LINK_LIBRARIES(enginephonon ${PHONON_LIBS} ${QTLIBS})
endif(ENABLE_QT5)

# ------------------------------------------------------------------------------
#  INSTALL
# ------------------------------------------------------------------------------  
if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
   set (CMAKE_INSTALL_PREFIX /usr CACHE PATH "default install path" FORCE )
endif()

set(CMAKE_INSTALL_LIB "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}/yarock"  CACHE PATH "libraries installation path" FORCE)

install(TARGETS enginephonon DESTINATION ${CMAKE_INSTALL_LIB} )

=== src/core/player/qtmultimedia/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)

project(engineqtmultimedia)
# ------------------------------------------------------------------------------
#  build def (QT PLUGIN)
# ------------------------------------------------------------------------------
ADD_DEFINITIONS( -Wall )
ADD_DEFINITIONS(-DQT_PLUGIN)
ADD_DEFINITIONS(-DQT_NO_DEBUG)
ADD_DEFINITIONS(-DQT_SHARED)
ADD_DEFINITIONS(-DQT_THREAD)


ADD_DEFINITIONS( -DENABLE_QTMULTIMEDIA )

# ------------------------------------------------------------------------------
#  EXTERNAL LIB
# ------------------------------------------------------------------------------
if(ENABLE_QT5)
  FIND_PACKAGE( Qt5Multimedia REQUIRED)
endif (ENABLE_QT5)    
 

# ------------------------------------------------------------------------------
#  INCLUDES
# ------------------------------------------------------------------------------
INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/core/player/
                     ${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/core/player/qtmultimedia
                     ${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/core/mediaitem
                     ${CMAKE_CURRENT_SOURCE_DIR}/../../../../src
)

if (ENABLE_QT5)
    set (QTLIBS ${Qt5Core_LIBRARIES} 
                ${Qt5Multimedia_LIBRARIES})
    
    set (QTINCLUDES ${Qt5Core_INCLUDE_DIRS}
                    ${Qt5Multimedia_INCLUDE_DIRS} )

    add_definitions( ${Qt5Core_DEFINITIONS} 
                     ${Qt5Multimedia_DEFINITIONS} )

    INCLUDE_DIRECTORIES( ${QTINCLUDES} )
    
endif(ENABLE_QT5)

# ------------------------------------------------------------------------------
#  SOURCES
# ------------------------------------------------------------------------------
SET(SOURCES
    ${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/core/player/qtmultimedia/engine_qtmultimedia.cpp
)

# ------------------------------------------------------------------------------
#  BUILDING
# ------------------------------------------------------------------------------
set( CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib )

ADD_LIBRARY( engineqtmultimedia SHARED ${SOURCES} )

SET_TARGET_PROPERTIES(engineqtmultimedia PROPERTIES AUTOMOC TRUE)

ADD_DEPENDENCIES(engineqtmultimedia yarock)

if(ENABLE_QT5)  
    TARGET_LINK_LIBRARIES(engineqtmultimedia ${QTLIBS})
endif(ENABLE_QT5)

# ------------------------------------------------------------------------------
#  INSTALL
# ------------------------------------------------------------------------------  
if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
   set (CMAKE_INSTALL_PREFIX /usr CACHE PATH "default install path" FORCE )
endif()

set(CMAKE_INSTALL_LIB "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}/yarock"  CACHE PATH "libraries installation path" FORCE)

install(TARGETS engineqtmultimedia DESTINATION ${CMAKE_INSTALL_LIB} )

=== src/core/player/vlc/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

project(enginevlc)
# ------------------------------------------------------------------------------
#  build def (QT PLUGIN)
# ------------------------------------------------------------------------------
ADD_DEFINITIONS( -Wall )
ADD_DEFINITIONS( -DQT_PLUGIN )
ADD_DEFINITIONS( -DQT_NO_DEBUG )
ADD_DEFINITIONS( -DQT_SHARED )
ADD_DEFINITIONS( -DQT_THREAD )


ADD_DEFINITIONS( -DENABLE_VLC )

# ------------------------------------------------------------------------------
#  EXTERNAL LIB
# ------------------------------------------------------------------------------
FIND_PACKAGE( LIBVLC REQUIRED )


# ------------------------------------------------------------------------------
#  INCLUDES
# ------------------------------------------------------------------------------
INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/core/player/
                     ${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/core/player/vlc
                     ${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/core/mediaitem
                     ${CMAKE_CURRENT_SOURCE_DIR}/../../../../src
)

INCLUDE_DIRECTORIES( ${LIBVLC_INCLUDE_DIR} )

if (ENABLE_QT5)
    set (QTLIBS ${Qt5Core_LIBRARIES})
    
    set (QTINCLUDES ${Qt5Core_INCLUDE_DIRS})

    add_definitions( ${Qt5Core_DEFINITIONS})

else (ENABLE_QT5)
    set (QTLIBS ${QT_QTCORE_LIBRARY})

    set (QTINCLUDES ${QT_INCLUDES})
    
    add_definitions(${QT_DEFINITIONS})    
endif (ENABLE_QT5)

INCLUDE_DIRECTORIES( ${QTINCLUDES} )


# ------------------------------------------------------------------------------
#  SOURCES
# ------------------------------------------------------------------------------
SET(SOURCES
    ${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/core/player/vlc/engine_vlc.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/core/player/vlc/vlc_lib.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/core/player/vlc/vlc_media.cpp
)

# ------------------------------------------------------------------------------
#  BUILDING
# ------------------------------------------------------------------------------
set( CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib )

ADD_LIBRARY( enginevlc SHARED ${SOURCES} )

SET_TARGET_PROPERTIES(enginevlc PROPERTIES AUTOMOC TRUE)

ADD_DEPENDENCIES(enginevlc yarock)

TARGET_LINK_LIBRARIES(enginevlc ${LIBVLC_LIBRARY} ${QTLIBS})

# ------------------------------------------------------------------------------
#  INSTALL
# ------------------------------------------------------------------------------  
if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
   set (CMAKE_INSTALL_PREFIX /usr CACHE PATH "default install path" FORCE )
endif()

set(CMAKE_INSTALL_LIB "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}/yarock"  CACHE PATH "libraries installation path" FORCE)

install(TARGETS enginevlc DESTINATION ${CMAKE_INSTALL_LIB} )

=== debian/changelog ===
yarock (1.3.1-0mx17) mx; urgency=medium

  * New upstream release
  * Packaged for MX-17

 -- Timothy E. Harris <maintainer@mxrepo.com>  Wed, 04 Jul 2018 20:35:57 -0400

=== debian/control ===
Source: yarock
Section: sound
Priority: extra
Maintainer: Timothy E. Harris <maintainer@mxrepo.com>
Bugs: mailto: maintainer@mxrepo.com
XSBC-Original-Maintainer: Rog131 <samrog131@hotmail.com>
Build-Depends: debhelper (>= 8.0), 
 cmake (>= 2.8.6),
 qtbase5-dev,
 qtbase5-private-dev,
 qttools5-dev-tools,
 libqt5x11extras5-dev,
 libphonon4qt5-dev, 
 libtag1-dev,
 libtag-extras-dev,
 pkg-config,
 libx11-dev,
 libhtmlcxx-dev,
 libqjson-dev,
 libmpv-dev,
 libvlc-dev,
 qtchooser | qt5-default | qtbase5-dev
Standards-Version: 3.9.6
Homepage: http://qt-apps.org/content/show.php/YaRock?content=129372

Package: yarock
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libqt5sql5-sqlite,
 phonon4qt5-backend-gstreamer | phonon4qt5-backend-vlc
Recommends: gstreamer1.0-plugins-good,
 gstreamer1.0-plugins-bad,
 gstreamer1.0-plugins-ugly
Description: a Qt based music player
 Yarock is a music player in c++/Qt designed to provide a clean, 
 simple and beautiful music collection based on album coverart.
 .
 Yarock is written in C++ using Qt and Phonon multimedia framework, only for 
 Linux platform.
 .
 Features include:
 * Music collection database (SQLite 3)
 * Browse your local music collection based on cover art 
 * Easy search and filter music collection
 * Manage favorites item (album, artist)
 * Play music directly from collection or playqueue
 * Simple Playqueue
 * Smart playlist generator 
 * Support mp3,Ogg Vorbis,flac music files (depending on phonon backend)
 * Support load/save playlist file (m3u, pls, xspf)
 * Play radio stream (icecast, shoutcast, user stream files)
 * Mp3Gain tag support for volume normalization
 * Cover art download (Last.fm/discogs services)
 * Last Fm scrobbler
 * Command line interface, Mpris interface
 * Clean and simple user interface 
 * No GNOME or KDE dependencies
 .
 http://qt-apps.org/content/show.php/YaRock?content=129372

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS
export QT_SELECT=qt5

%:
	dh $@ --parallel

override_dh_auto_configure:
	cmake -DCMAKE_BUILD_TYPE=Release \
       -DCMAKE_INSTALL_PREFIX=/usr \
       -DENABLE_MPV=ON \
       -DENABLE_PHONON=ON

## yarock 1.4.0+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,8 +6,8 @@
 
 PROJECT( yarock )
 set(YAROCK_MAJOR_VERSION 1)
-set(YAROCK_MINOR_VERSION 3)
-set(YAROCK_PATCH_VERSION 1)
+set(YAROCK_MINOR_VERSION 4)
+set(YAROCK_PATCH_VERSION 0)
 set(YAROCK_VERSION "${YAROCK_MAJOR_VERSION}.${YAROCK_MINOR_VERSION}.${YAROCK_PATCH_VERSION}")
 
 # ------------------------------------------------------------------------------
@@ -287,10 +287,10 @@
 install(FILES ${YAROCK_QM_FILES} DESTINATION "${CMAKE_INSTALL_PREFIX}/share/yarock/translations")
 
 # -- install destop file
-install(FILES data/yarock.desktop  DESTINATION "${CMAKE_INSTALL_PREFIX}/share/applications" )
+install(FILES data/org.yarock.desktop  DESTINATION "${CMAKE_INSTALL_PREFIX}/share/applications" )
 
 # -- install appdata file
-install(FILES data/yarock.appdata.xml  DESTINATION "${CMAKE_INSTALL_PREFIX}/share/appdata" )
+install(FILES data/org.yarock.appdata.xml  DESTINATION "${CMAKE_INSTALL_PREFIX}/share/appdata" )
 
 # -- install icons files
 INSTALL( FILES ${CMAKE_SOURCE_DIR}/icon/yarock_16x16.png DESTINATION "${CMAKE_INSTALL_PREFIX}/share/icons/hicolor/16x16/apps" RENAME application-x-yarock.png)
@@ -299,9 +299,5 @@
 INSTALL( FILES ${CMAKE_SOURCE_DIR}/icon/yarock_64x64.png DESTINATION "${CMAKE_INSTALL_PREFIX}/share/icons/hicolor/64x64/apps" RENAME application-x-yarock.png)
 INSTALL( FILES ${CMAKE_SOURCE_DIR}/icon/yarock_128x128.png DESTINATION "${CMAKE_INSTALL_PREFIX}/share/icons/hicolor/128x128/apps" RENAME application-x-yarock.png)
 INSTALL( FILES ${CMAKE_SOURCE_DIR}/icon/yarock.svg DESTINATION "${CMAKE_INSTALL_PREFIX}/share/icons/hicolor/scalable/apps" RENAME application-x-yarock.svg)
-
-# ------------------------------------------------------------------------------
-#  UN-INSTALL SUPPORT
-# ------------------------------------------------------------------------------
-
- 
+INSTALL( FILES ${CMAKE_SOURCE_DIR}/icon/yarock_48x48.png DESTINATION "${CMAKE_INSTALL_PREFIX}/share/pixmaps/" RENAME application-x-yarock.png)
+

=== src/core/player/phonon/CMakeLists.txt ===
--- 
+++ 
@@ -34,7 +34,7 @@
 
 
 if (ENABLE_QT5)
-    INCLUDE_DIRECTORIES( ${PHONON_INCLUDE_DIR}/phonon4qt5 )
+    INCLUDE_DIRECTORIES( ${PHONON4QT5_INCLUDE_DIR}/phonon4qt5 )
 else (ENABLE_QT5)
     INCLUDE_DIRECTORIES( ${PHONON_INCLUDES} )
 endif (ENABLE_QT5)

=== src/core/player/vlc/CMakeLists.txt ===
--- 
+++ 
@@ -49,6 +49,12 @@
 
 
 # ------------------------------------------------------------------------------
+#  configure file
+# ------------------------------------------------------------------------------
+configure_file(${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/config.h.in
+               ${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/core/player/vlc/config.h)
+               
+# ------------------------------------------------------------------------------
 #  SOURCES
 # ------------------------------------------------------------------------------
 SET(SOURCES
@@ -57,6 +63,8 @@
     ${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/core/player/vlc/vlc_media.cpp
 )
 
+
+               
 # ------------------------------------------------------------------------------
 #  BUILDING
 # ------------------------------------------------------------------------------

=== debian/changelog ===
yarock (1.4.0+dfsg-1+20201123+2101+amd64+build1) 2101+amd64; urgency=medium

  * Automatic CI Build

 -- Debian CI <null@debian.org>  Mon, 07 Dec 2020 20:01:58 +0000

yarock (1.4.0+dfsg-1) unstable; urgency=medium

  * Initial Release. (Closes: #920688)

 -- Scarlett Moore <sgmoore@kde.org>  Mon, 28 Jan 2019 03:55:42 -0700

=== debian/control ===
Source: yarock
Section: sound
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Scarlett Moore <sgmoore@kde.org>
Build-Depends: cmake,
               debhelper (>= 12),
               libhtmlcxx-dev,
               libphonon4qt5-dev,
               libqt5sql5-sqlite,
               libqt5x11extras5-dev,
               libtag1-dev,
               libx11-dev,
               pkg-config,
               qtbase5-dev,
               qtbase5-dev-tools,
               qtbase5-private-dev,
               qttools5-dev,
               qttools5-dev-tools
Standards-Version: 4.3.0
Homepage: http://qt-apps.org/content/show.php/YaRock?content=129372
Vcs-Git: https://github.com/dci-extras-packaging/yarock
Vcs-Browser: https://github.com/dci-extras-packaging/yarock

Package: yarock
Architecture: any
Depends: libqt5sql5-sqlite,
         phonon4qt5-backend-gstreamer,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: gstreamer1.0-plugins-bad,
            gstreamer1.0-plugins-good,
            gstreamer1.0-plugins-ugly
Description: Qt based music player
 Yarock is a music player in c++/Qt designed to provide a clean,
 simple and beautiful music collection based on album coverart.
 .
 Yarock is written in C++ using Qt and Phonon multimedia framework, only for
 linux platform.
 .
 Features include:
  * Music collection database (SQLite 3)
  * Browse your local music collection based on cover art
  * Easy search and filter music collection
  * Manage favorites item (album, artist)
  * Play music directly from collection or playqueue
  * Simple Playqueue
  * Smart playlist generator
  * Support mp3,Ogg Vorbis,flac music files (depending on phonon backend)
  * Support load/save playlist file (m3u, pls, xspf)
  * Play radio stream (icecast, shoutcast, user stream files)
  * Mp3Gain tag support for volume normalization
  * Cover art download (Last.fm/discogs services)
  * Last Fm scrobbler
  * Command line interface, Mpris interface
  * Clean and simple user interface
  * No GNOME or KDE dependencies

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_BUILD_TYPE=Release -DCMAKE_INSTALL_PREFIX=/usr \
	-DENABLE_QT5=1 -DENABLE_VLC=OFF -DENABLE_MPV=OFF -DENABLE_PHONON=ON

override_dh_auto_install:
	dh_auto_install
	rm -f $(CURDIR)/debian/yarock/usr/share/doc/yarock/COPYING.gz

=== debian/watch ===
version=4
opts="repacksuffix=+dfsg,\
repack,compression=xz,\
dversionmangle=s/\+(debian|dfsg|ds|deb)(\.?\d+)?$//" \
https://launchpad.net/yarock/+download .*/Yarock@ANY_VERSION@_Sources@ARCHIVE_EXT@
